program exercise13
  implicit none
  
  double precision :: x

  x = -10.0d0  ! xは-10からスタート
  
  do ! doループの終了条件はif文で与える
     
     print *, x, exp(x), exptaylor(x,10), exptaylor(x,20), exptaylor(x,30),exptaylor(x,40) ! 結果の出力

     x = x + 0.50d0 ! xを0.5増やす

     if( x > 10.001d0) exit !xが10を超えたらdoループから抜ける。10だと実数の場合10が入らない場合があるので少し大きくしておく
     
  end do

  ! プログラムはここまで
  
contains

  function exptaylor(x,n) !e^xをテーラー展開してn次まで計算する関数副プログラム
    integer, intent(in) :: n           ! 整数型引数nはテーラー展開の次数
    double precision, intent(in) :: x  ! 倍精度実数型引数xは関数の変数
    double precision :: exptaylor      ! 関数の返す倍精度実数型変数
    integer :: k
    
    exptaylor = 0.0d0  ! 初期値をセット

    do k = 0, n        ! kがゼロからdoループを回して展開項を計算

       exptaylor = exptaylor + x**k / factorial(k) ! k!は別の関数副プログラムを呼び出して計算
       
    end do
    
    return  ! exptaylorの値を返して関数副プログラムを終了

  end function exptaylor  

 function factorial(n) ! 階乗の計算
    integer, intent(in) :: n  
    integer :: k
    double precision :: factorial 

    factorial = 0.0d0   
    if(n < 0) return

    factorial = 1.0d0   
    if(n == 0) return 

    do k = 1, n 
       factorial = factorial * dble(k) 
    end do

    return 
    
  end function factorial
  
end program exercise13
